import PyQt4.QtGui as QtWidgets

import Parameters


class CreateSamplesProperties(QtWidgets.QDockWidget):
    
    def __init__(self, parent):
        super(CreateSamplesProperties, self).__init__(parent)
        
        self.__parent = parent
        
        self.classComboBox = QtWidgets.QComboBox()
        for i in range(Parameters.NUMBER_SUPPORTED_CLASSES):
            self.classComboBox.addItem('Class {0}'.format(i + 1))
        
        self.assignButton = QtWidgets.QPushButton('Assign class label')
        self.assignButton.setEnabled(False)
        self.assignButton.clicked.connect(self.onAssignClassLabel)
        
        self.deleteButton = QtWidgets.QPushButton('Delete samples')
        self.deleteButton.setEnabled(False)
        self.deleteButton.clicked.connect(self.onDeleteSamples)
               
        layout = QtWidgets.QHBoxLayout()
        layout.setContentsMargins(5, 0, 5, 0)
        layout.addWidget(self.classComboBox)
        layout.addWidget(self.assignButton)
        layout.addWidget(self.deleteButton)
        layout.addStretch(1)
        
        widget = QtWidgets.QWidget()        
        widget.setLayout(layout)
        
        self.setWidget(widget)
        self.setFeatures(QtWidgets.QDockWidget.NoDockWidgetFeatures)
        self.setTitleBarWidget(QtWidgets.QWidget(self));
        self.setHidden(True)        


    def getProperties(self):
        return (self.classComboBox.currentIndex())


    def onDeleteSamples(self):
        self.__parent.featurespace.samples.deleteSamplesInSelectedArea()


    def onAssignClassLabel(self):
        self.__parent.featurespace.samples.assignNewClassLabelInSelectedArea(self.classComboBox.currentIndex())


