import PyQt4.QtGui as QtWidgets

from PrincipalComponentAnalysis import PrincipalComponentAnalysis


class DimensionalityReduction(object):
	
	PCA = 1
	
	
	def __init__(self, method, parameters, featurespace):
		super(DimensionalityReduction, self).__init__()
		
		self.__method = method
		self.__parameters = parameters
		self.__featurespace = featurespace
		self.__dimred = None


	def initialize(self):
		NoG = self.__featurespace.getNumberOfGaussians()
		if NoG > 0:
			QtWidgets.QMessageBox.warning(self.__featurespace, 'Error',
				'These techniques change the coordinates of the samples. ' +
				'Convert Gaussians to individual samples first.',
				QtWidgets.QMessageBox.Ok, QtWidgets.QMessageBox.Ok)	
			return		
		
		self.__samples, self.__labels = self.__featurespace.getSamples()
		if len(self.__labels) == 0:
			self.__dimred = None
			return
		
		if self.__method == self.PCA:
			dimReduction = self.__parameters.getPCARedDim()
			secondComponent = self.__parameters.getPCASecondComponent()
			backprojection = self.__parameters.getPCABackproject()
			
			self.__dimred = PrincipalComponentAnalysis(dimReduction, secondComponent, backprojection)
			Z = self.__dimred.fit(self.__samples)
			self.__featurespace.setSamples(Z)
			
		else:
			print("Unsupported dimensionality reduction method")

