from datetime import date
import json

from Parameters import resource_path

__build__ = 8
__versiondate__ = date(2016, 5, 10)

def readVersionInfo():
	global __build__
	global __versiondate__
	try:
		with open(resource_path('./version.json')) as f:
			info = json.load(f)
			__build__ = int(info['build'])
			__versiondate__ = date.fromordinal(int(info['date']))	
	except:
		print("Error: could not read version info from file 'version.json'")


def writeVersionInfo():
	try:
		with open(resource_path('./version.json'), 'w') as f:
			info = {'build': __build__, 'date': __versiondate__.toordinal()}
			json.dump(info, f)
	except:
		print("Error: could not write version info to file 'version.json'")


def incVersion():
	global __build__
	global __versiondate__
	__build__ += 1
	__versiondate__ = date.today()


def main():
	global __build__
	global __versiondate__
	readVersionInfo()
	incVersion()
	print("Incrementing the build number to {0} and updating the version date to {1}.".format(__build__, __versiondate__))
	writeVersionInfo()

if __name__ == '__main__':
	main()

readVersionInfo()

